#include "stdafx.h"
#include "math.h"
#include "prim.h"
#include "render.h"

namespace Render {

D3DXVECTOR3 BG_COLOR = D3DXVECTOR3(0.25f, 0.4f, 0.5f);

class CCamera
{
private:
	D3DXMATRIX  m_mView;
	D3DXMATRIX  m_mProj;
	D3DXMATRIX  m_mVP;
	D3DXMATRIX  m_mVP_Inv;
	D3DXMATRIX  m_mView_Inv;

	D3DXVECTOR3 m_vFrom;
	D3DXVECTOR3 m_vLookat;
	D3DXVECTOR3 m_vUp;

	float	m_fFovy;
	float	m_fAspect;
	float   m_fNear;
	float   m_fFar;

public:

	void Update();
	void SetFrom  (const D3DXVECTOR3 *p){m_vFrom  =*p;}
	void SetLookAt(const D3DXVECTOR3 *p){m_vLookat=*p;}
	void SetUp    (const D3DXVECTOR3 *p){m_vUp    =*p;}
	void SetFovY  (float val){m_fFovy   = val;}
	void SetAspect(float val){m_fAspect = val;}
	void SetNear  (float val){m_fNear   = val;}
	void SetFar   (float val){m_fFar    = val;}

	inline const D3DXMATRIX *GetViewInverse() const {return &m_mView_Inv;}
	inline const D3DXMATRIX *GetViewProjInverse() const {return &m_mVP_Inv;}
	inline void GetFrom (D3DXVECTOR3 *dest) const {*dest = m_vFrom;}
};


// ---------------------------------------------------------------------------
// IuWFNg
// ---------------------------------------------------------------------------
char s_data[4*RENDER_WIDTH*RENDER_HEIGHT];// zt[obt@
CCamera camera;

CMesh *pRoom       = NULL;
CMesh *pBlockSmall = NULL;
CMesh *pBlockTall  = NULL;
CMesh *pShpereS    = NULL;
CMesh *pShpereT    = NULL;

static int s_x = 0;
static int s_y = 0;
static int s_state = 0;
enum{
	STATE_IDLE=0,
	STATE_RENDER,
};

// ---------------------------------------------------------------------------
// 
OBJ_DATA sphere_data[] = {
{// ̂ɏĂق
	OBJ_TYPE_SPHERE,
	{
		{0.01f, 0.05f, 0.02f },
		{0.01f, 0.05f, 0.02f },
		{0.10f, 0.10f, 0.10f },
		16.0f,
	},{{0,0,0},{0,0,0},{0,0,0}},{
		{185.5, 165+100,169},
		100.0f,
	}
},{// 傫̂ɏĂق
	OBJ_TYPE_SPHERE,
	{
		{0.02f, 0.01f, 0.05f},
		{0.02f, 0.01f, 0.05f},
		{0.10f, 0.10f, 0.10f },
		8.0f,
	},{{0,0,0},{0,0,0},{0,0,0}},{
		{368.5, 330+100,351},
		100.0f,
	}
}};
// ---------------------------------------------------------------------------
// 
OBJ_DATA room_data[12] = {
{// CgP
	OBJ_TYPE_TRIANGLE,
	{
		{100.0f, 100.0f, 100.0f},
		{  0.0f,   0.0f,   0.0f},
		{  0.0f,   0.0f,   0.0f},
		0.0f,
	},{
		{213.0, 548.799f, 227.0},
		{213.0, 548.799f, 332.0},
		{343.0, 548.799f, 227.0},
	}
},{// CgQ
	OBJ_TYPE_TRIANGLE,
	{
		{100.0f, 100.0f, 100.0f},
		{  0.0f,   0.0f,   0.0f},
		{  0.0f,   0.0f,   0.0f},
		0.0f,
	},{
		{343.0, 548.799f, 227.0},
		{213.0, 548.799f, 332.0},
		{343.0, 548.799f, 332.0},
	}
},{// P
	OBJ_TYPE_TRIANGLE,
	{
		{0.05f, 0.01f, 0.01f},
		{0.05f, 0.01f, 0.01f},
		{0.00f, 0.00f, 0.00f},
		32.0f,
	},{
		{552.8f,   0.0f,   0.0f},
		{556.0f, 548.8f,   0.0f},
		{549.6f,   0.0f, 559.2f},
	}

},{// Q
	OBJ_TYPE_TRIANGLE,
	{
		{0.05f, 0.01f, 0.01f},
		{0.05f, 0.01f, 0.01f},
		{0.00f, 0.00f, 0.00f},
		32.0f,
	},{
		{549.6f,   0.0f, 559.2f},
		{556.0f, 548.8f,   0.0f},
		{556.0f, 548.8f, 559.2f},
	}

},{// EP
	OBJ_TYPE_TRIANGLE,
	{
		{0.01f, 0.01f, 0.05f},
		{0.01f, 0.01f, 0.05f},
		{0.00f, 0.00f, 0.00f},
		32.0f,
	},{
		{0.0f,   0.0f,   0.0f},
		{0.0f,   0.0f, 559.2f},
		{0.0f, 548.8f,   0.0f},
	}

},{// EQ
	OBJ_TYPE_TRIANGLE,
	{
		{0.01f, 0.01f, 0.05f},
		{0.01f, 0.01f, 0.05f},
		{0.00f, 0.00f, 0.00f},
		32.0f,
	},{
		{0.0f, 548.8f,   0.0f},
		{0.0f,   0.0f, 559.2f},
		{0.0f, 548.8f, 559.2f},
	}

},{// P
	OBJ_TYPE_TRIANGLE,
	{
		{0.05f, 0.05f, 0.05f},
		{0.05f, 0.05f, 0.05f},
		{0.00f, 0.00f, 0.00f},
		32.0f,
	},{
		{  0.0f,   0.0f, 559.2f},
		{549.6f,   0.0f, 559.2f},
		{  0.0f, 548.8f, 559.2f},
	}

},{// Q
	OBJ_TYPE_TRIANGLE,
	{
		{0.05f, 0.05f, 0.05f},
		{0.05f, 0.05f, 0.05f},
		{0.00f, 0.00f, 0.00f},
		32.0f,
	},{
		{  0.0f, 548.8f, 559.2f},
		{549.6f,   0.0f, 559.2f},
		{556.0f, 548.8f, 559.2f},
	}

},{// VP
	OBJ_TYPE_TRIANGLE,
	{
		{0.05f, 0.05f, 0.05f},
		{0.05f, 0.05f, 0.05f},
		{0.00f, 0.00f, 0.00f},
		32.0f,
	},{
		{  0.0f, 548.8f,   0.0f},
		{  0.0f, 548.8f, 559.2f},
		{556.0f, 548.8f,   0.0f},
	}

},{// VQ
	OBJ_TYPE_TRIANGLE,
	{
		{0.05f, 0.05f, 0.05f},
		{0.05f, 0.05f, 0.05f},
		{0.00f, 0.00f, 0.00f},
		32.0f,
	},{
		{  0.0f, 548.8f, 559.2f},
		{556.0f, 548.8f, 559.2f},
		{556.0f, 548.8f,   0.0f},
	}

},{// P
	OBJ_TYPE_TRIANGLE,
	{
		{0.05f, 0.05f, 0.05f},
		{0.05f, 0.05f, 0.05f},
		{0.00f, 0.00f, 0.00f},
		32.0f,
	},{
		{  0.0f, 0.0f,   0.0f},
		{552.8f, 0.0f,   0.0f},
		{  0.0f, 0.0f, 559.2f},
	}
},{// P
	OBJ_TYPE_TRIANGLE,
	{
		{0.05f, 0.05f, 0.05f},
		{0.05f, 0.05f, 0.05f},
		{0.00f, 0.00f, 0.00f},
		32.0f,
	},{
		{  0.0f, 0.0f, 559.2f},
		{552.8f, 0.0f,   0.0f},
		{549.6f, 0.0f, 559.2f},
	}
}};

// ---------------------------------------------------------------------------
// Ⴂ
OBJ_DATA Short_block[] = {
{
	// 
	OBJ_TYPE_TRIANGLE,
	{
		{0.05f, 0.05f, 0.05f},
		{0.05f, 0.05f, 0.05f},
		{0.00f, 0.00f, 0.00f},
		32.0f,
	},{
		{ 82.0f, 165.0f, 225.0f},
		{130.0f, 165.0f,  65.0f},
		{240.0f, 165.0f, 272.0f},
	}
},{
	OBJ_TYPE_TRIANGLE,
	{
		{0.05f, 0.05f, 0.05f},
		{0.05f, 0.05f, 0.05f},
		{0.00f, 0.00f, 0.00f},
		32.0f,
	},{
		{290.0, 165.0, 114.0},
		{240.0, 165.0, 272.0},
		{130.0, 165.0,  65.0},
	}
},{//
	OBJ_TYPE_TRIANGLE,
	{
		{0.05f, 0.05f, 0.05f},
		{0.05f, 0.05f, 0.05f},
		{0.00f, 0.00f, 0.00f},
		32.0f,
	},{
		{290.0, 165.0, 114.0},
		{290.0,   0.0, 114.0},
		{240.0, 165.0, 272.0},
	}
},{
	OBJ_TYPE_TRIANGLE,
	{
		{0.05f, 0.05f, 0.05f},
		{0.05f, 0.05f, 0.05f},
		{0.00f, 0.00f, 0.00f},
		32.0f,
	},{
		{240.0, 165.0, 272.0},
		{290.0,   0.0, 114.0},
		{240.0,   0.0, 272.0},
	}
},{//O
	OBJ_TYPE_TRIANGLE,
	{
		{0.05f, 0.05f, 0.05f},
		{0.05f, 0.05f, 0.05f},
		{0.00f, 0.00f, 0.00f},
		32.0f,
	},{
		{290.0,   0.0, 114.0},
		{290.0, 165.0, 114.0},
		{130.0,   0.0,  65.0},
	}
},{
	OBJ_TYPE_TRIANGLE,
	{
		{0.05f, 0.05f, 0.05f},
		{0.05f, 0.05f, 0.05f},
		{0.00f, 0.00f, 0.00f},
		32.0f,
	},{
		{130.0,   0.0,  65.0},
		{290.0, 165.0, 114.0},
		{130.0, 165.0,  65.0},
	}
},{//
	OBJ_TYPE_TRIANGLE,
	{
		{0.05f, 0.05f, 0.05f},
		{0.05f, 0.05f, 0.05f},
		{0.00f, 0.00f, 0.00f},
		32.0f,
	},{
		{ 82.0,   0.0, 225.0},
		{130.0, 165.0,  65.0},
		{ 82.0, 165.0, 225.0},
	}
},{
	OBJ_TYPE_TRIANGLE,
	{
		{0.05f, 0.05f, 0.05f},
		{0.05f, 0.05f, 0.05f},
		{0.00f, 0.00f, 0.00f},
		32.0f,
	},{
		{ 82.0,   0.0, 225.0},
		{130.0,   0.0,  65.0},
		{130.0, 165.0,  65.0},
	}
},{//w
	OBJ_TYPE_TRIANGLE,
	{
		{0.05f, 0.05f, 0.05f},
		{0.05f, 0.05f, 0.05f},
		{0.00f, 0.00f, 0.00f},
		32.0f,
	},{
		{240.0,   0.0, 272.0},
		{ 82.0, 165.0, 225.0},
		{240.0, 165.0, 272.0},
	}
},{
	OBJ_TYPE_TRIANGLE,
	{
		{0.05f, 0.05f, 0.05f},
		{0.05f, 0.05f, 0.05f},
		{0.00f, 0.00f, 0.00f},
		32.0f,
	},{
		{240.0,   0.0, 272.0},
		{ 82.0,   0.0, 225.0},
		{ 82.0, 165.0, 225.0},
	}
}};

// ---------------------------------------------------------------------------
// 
OBJ_DATA Tall_block[] = {
{
	// 
	OBJ_TYPE_TRIANGLE,
	{
		{0.05f, 0.05f, 0.05f},
		{0.05f, 0.05f, 0.05f},
		{0.00f, 0.00f, 0.00f},
		32.0f,
	},{
		{423.0f, 330.0f, 247.0f},
		{314.0f, 330.0f, 456.0f},
		{265.0f, 330.0f, 296.0f},
	}
},{
	OBJ_TYPE_TRIANGLE,
	{
		{0.05f, 0.05f, 0.05f},
		{0.05f, 0.05f, 0.05f},
		{0.00f, 0.00f, 0.00f},
		32.0f,
	},{
		{423.0f, 330.0f, 247.0f},
		{472.0f, 330.0f, 406.0f},
		{314.0f, 330.0f, 456.0f},
	}
},{//
	OBJ_TYPE_TRIANGLE,
	{
		{0.05f, 0.05f, 0.05f},
		{0.05f, 0.05f, 0.05f},
		{0.00f, 0.00f, 0.00f},
		32.0f,
	},{
		{423.0f,   0.0f, 247.0f},
		{472.0f,   0.0f, 406.0f},
		{423.0f, 330.0f, 247.0f},
	}
},{
	OBJ_TYPE_TRIANGLE,
	{
		{0.05f, 0.05f, 0.05f},
		{0.05f, 0.05f, 0.05f},
		{0.00f, 0.00f, 0.00f},
		32.0f,
	},{
		{423.0f, 330.0f, 247.0f},
		{472.0f,   0.0f, 406.0f},
		{472.0f, 330.0f, 406.0f},
	}
},{//w
	OBJ_TYPE_TRIANGLE,
	{
		{0.05f, 0.05f, 0.05f},
		{0.05f, 0.05f, 0.05f},
		{0.00f, 0.00f, 0.00f},
		32.0f,
	},{
		{314.0f,   0.0f, 456.0f},
		{314.0f, 330.0f, 456.0f},
		{472.0f,   0.0f, 406.0f},
	}
},{
	OBJ_TYPE_TRIANGLE,
	{
		{0.05f, 0.05f, 0.05f},
		{0.05f, 0.05f, 0.05f},
		{0.00f, 0.00f, 0.00f},
		32.0f,
	},{
		{314.0f, 330.0f, 456.0f},
		{472.0f, 330.0f, 406.0f},
		{472.0f,   0.0f, 406.0f},
	}
},{//
	OBJ_TYPE_TRIANGLE,
	{
		{0.05f, 0.05f, 0.05f},
		{0.05f, 0.05f, 0.05f},
		{0.00f, 0.00f, 0.00f},
		32.0f,
	},{
		{314.0f,   0.0f, 456.0f},
		{265.0f,   0.0f, 296.0f},
		{265.0f, 330.0f, 296.0f},
	}
},{
	OBJ_TYPE_TRIANGLE,
	{
		{0.05f, 0.05f, 0.05f},
		{0.05f, 0.05f, 0.05f},
		{0.00f, 0.00f, 0.00f},
		32.0f,
	},{
		{314.0f,   0.0f, 456.0f},
		{265.0f, 330.0f, 296.0f},
		{314.0f, 330.0f, 456.0f},
	}
},{//O
	OBJ_TYPE_TRIANGLE,
	{
		{0.05f, 0.05f, 0.05f},
		{0.05f, 0.05f, 0.05f},
		{0.00f, 0.00f, 0.00f},
		32.0f,
	},{
		{265.0f,   0.0f, 296.0f},
		{423.0f,   0.0f, 247.0f},
		{265.0f, 330.0f, 296.0f},
	}
},{
	OBJ_TYPE_TRIANGLE,
	{
		{0.05f, 0.05f, 0.05f},
		{0.05f, 0.05f, 0.05f},
		{0.00f, 0.00f, 0.00f},
		32.0f,
	},{
		{265.0f, 330.0f, 296.0f},
		{423.0f,   0.0f, 247.0f},
		{423.0f, 330.0f, 247.0f},
	}
}};


// ---------------------------------------------------------------------------
// ֐錾
// ---------------------------------------------------------------------------
D3DXVECTOR3 *GetColor(D3DXVECTOR3 *dest, float x, float y);


// ---------------------------------------------------------------------------
// JNX
// ---------------------------------------------------------------------------
void CCamera::Update()
{
    D3DXMatrixLookAtLH( &m_mView, &m_vFrom, &m_vLookat, &m_vUp );
    D3DXMatrixPerspectiveFovLH( &m_mProj, m_fFovy, m_fAspect, m_fNear, m_fFar );
	m_mVP = m_mView * m_mProj;

	D3DXMatrixInverse( &m_mView_Inv, NULL, &m_mView);
	D3DXMatrixInverse( &m_mVP_Inv, NULL, &m_mVP);
}
// ---------------------------------------------------------------------------
char *GetDataPointer()
{
	return s_data;
}

// ---------------------------------------------------------------------------
void Init()
{
	camera.SetFrom  (&D3DXVECTOR3(278,273,-800));
	camera.SetLookAt(&D3DXVECTOR3(278,273,0));
	camera.SetUp    (&D3DXVECTOR3(0,1,0));
	camera.SetFovY  (D3DX_PI/4);
	camera.SetAspect(1.0f);
	camera.SetNear  (0.01f);
	camera.SetFar   (100.0f);
	camera.Update();

	pRoom = new CMesh();
	pRoom->Init( room_data, 12 );
	
	pBlockSmall = new CMesh();
	pBlockSmall->Init( Short_block, 10);

	pBlockTall = new CMesh();
	pBlockTall->Init( Tall_block, 10);
	
	pShpereS = new CMesh();
	pShpereS->Init( sphere_data, 1);
	
	pShpereT = new CMesh();
	pShpereT->Init( sphere_data+1,1);

	Begin();// t[obt@̏
}
// ---------------------------------------------------------------------------
void Delete()
{
	if(pShpereT){delete pShpereT;pShpereT=NULL;}
	if(pShpereS){delete pShpereS;pShpereS=NULL;}
	if(pBlockTall){delete pBlockTall;pBlockTall=NULL;}
	if(pBlockSmall){delete pBlockSmall;pBlockSmall=NULL;}
	if(pRoom){delete pRoom; pRoom=NULL;}
}
// ---------------------------------------------------------------------------
void Begin()
{
	s_state = STATE_RENDER;
	
	s_x = 0;
	s_y = 0;

	// t[obt@̏
	for(int j=0; j<RENDER_HEIGHT; j++){
	for(int i=0; i<RENDER_WIDTH ; i++){
		s_data[4*(j*RENDER_WIDTH+i)+0]=(char)255;// R
		s_data[4*(j*RENDER_WIDTH+i)+1]=(char)(i*256/RENDER_WIDTH );// G
		s_data[4*(j*RENDER_WIDTH+i)+2]=(char)(j*256/RENDER_HEIGHT);// B
	}
	}
}
// ---------------------------------------------------------------------------
int Render()
{
	if(STATE_IDLE == s_state) return 0;
	
	D3DXVECTOR3 col;
	GetColor(&col, ((float)s_x+0.5f)/(float)RENDER_WIDTH
				 , ((float)s_y+0.5f)/(float)RENDER_HEIGHT);
	s_data[4*(s_y*RENDER_WIDTH+s_x)+0]=(char)(255.9*min(1,col.x));// R
	s_data[4*(s_y*RENDER_WIDTH+s_x)+1]=(char)(255.9*min(1,col.y));// G
	s_data[4*(s_y*RENDER_WIDTH+s_x)+2]=(char)(255.9*min(1,col.z));// B
	
	// ̃sNZɈړ
	if(RENDER_WIDTH<=++s_x){
		// sς
		s_x = 0;
		if(RENDER_HEIGHT<=++s_y){
			s_state = STATE_IDLE;// I
			return 0;
		}
	}

	return -1;
}

// ---------------------------------------------------------------------------
D3DXVECTOR3 *GetColor(D3DXVECTOR3 *dest, D3DXVECTOR4 *x, D3DXVECTOR4 *v)
{
	D3DXVECTOR4 light_pos = D3DXVECTOR4(278.f, 548.8f, 279.5f,1);
	
	float t = CPrimitive::INFINTY_DIST;
	CPrimitive *pObj = NULL;
	D3DXVECTOR4 p, ptmp;
	D3DXVECTOR4 n, ntmp;
	
	t = pShpereS   ->IsAcross(t, &n, &p, &pObj, x, v);
	t = pShpereT   ->IsAcross(t, &n, &p, &pObj, x, v);
	t = pRoom      ->IsAcross(t, &n, &p, &pObj, x, v);
	t = pBlockSmall->IsAcross(t, &n, &p, &pObj, x, v);
	t = pBlockTall ->IsAcross(t, &n, &p, &pObj, x, v);

	if( pObj ){
		// I

		D3DXVECTOR4 l = light_pos-p;
		float L2 = D3DXVec3Length((D3DXVECTOR3 *)&l);
		D3DXVec3Normalize((D3DXVECTOR3 *)&l, (D3DXVECTOR3 *)&l);

		D3DXVECTOR3 dir, H;
		// ̌vZ
		camera.GetFrom(&dir);
		dir = dir - *(D3DXVECTOR3 *)&p;
		D3DXVec3Normalize(&dir, &dir);
		// n[txNg
		H = dir+*(D3DXVECTOR3 *)&l;
		D3DXVec3Normalize((D3DXVECTOR3 *)&H, (D3DXVECTOR3 *)&H);

		float LN = D3DXVec3Dot((D3DXVECTOR3 *)&l, (D3DXVECTOR3 *)&n);
		float HN = D3DXVec3Dot((D3DXVECTOR3 *)&H, (D3DXVECTOR3 *)&n);
		if(HN<0) HN=0;
		if(0<LN){
			// Ƃ납A邩𔻒
			// Ȃ΁AÂ
			bool bShadow = FALSE;
			if(!bShadow) bShadow = pShpereS   ->IsAcross(L2, &p, &l);
			if(!bShadow) bShadow = pShpereT   ->IsAcross(L2, &p, &l);
			if(!bShadow) bShadow = pRoom      ->IsAcross(L2, &p, &l);
			if(!bShadow) bShadow = pBlockSmall->IsAcross(L2, &p, &l);
			if(!bShadow) bShadow = pBlockTall ->IsAcross(L2, &p, &l);
			if(bShadow) LN*=0.0f;// difuseȂ
		}else{
			LN=0;
		}
		
		pObj->GetColor(dest, LN, HN);
		
		// ̐F̔f
		D3DXVECTOR3 light_color = D3DXVECTOR3(10.f,9.0f,5.0f);
		dest->x *= light_color.x;
		dest->y *= light_color.y;
		dest->z *= light_color.z;
		
		// ̋̓Kȕ␳
		*dest *= min(1.5f, 500000.0f/(10000.0f+L2)); // ɂ␳
		*dest *= min(1, l.y+0.1f);					// ̌cosƂ̊֐ɂ
	}else{
		// O
		*dest = BG_COLOR;
	}


	return dest;
}
// ---------------------------------------------------------------------------
D3DXVECTOR3 *GetColor(D3DXVECTOR3 *dest, float x, float y)
{
	D3DXVECTOR4 ray_start_proj = D3DXVECTOR4(-2*x+1, -2*y+1, 0, 1);// ONbv
	D3DXVECTOR4 ray_eye        = D3DXVECTOR4(0, 0, 0, 1);// r[Ԃł̃J̈ʒu
	D3DXVECTOR4 ray_start;
	D3DXVECTOR4 ray_to;
	D3DXVECTOR4 ray_dir;
	D3DXMATRIX mInv;
	
	// _ˉeԂ烏[hWɕϊ
	D3DXVec4Transform( &ray_start, &ray_eye,        camera.GetViewInverse() );
	D3DXVec4Transform( &ray_to,    &ray_start_proj, camera.GetViewProjInverse() );
	D3DXVec4Scale( &ray_to,    &ray_to,    1.0f/ray_to.w   );// w=1 ̎ˉeԂɗƂ
	// ̌vZ
	ray_dir = ray_to - ray_start;
	D3DXVec4Normalize(&ray_dir, &ray_dir);
	
	GetColor(dest, &ray_start, &ray_dir);

	return dest;
}

};// namespace Render
